#include <iostream>

using namespace std;


int main()
{
    int n,q,l,r,konj;
    cin >> n >> q;
    int A[n];
    int odg[q];
    for(int i=1;i<=n;i++)
    {
        cin >> A[i];
    }
    for(int i=0;i<q;i++)
    {
        cin >> l >> r;
        konj=A[l];
        for(int j=l;j<=r;j++)
        {
            konj=konj&A[j];
            if(konj==0)
                break;
        }
        odg[i]=konj;

    }
    for(int i=0;i<q;i++)
        cout << odg[i] << endl;
    return 0;
}